/*
 * Newt-Puzzle
 * Copyright (C) Aude Jaulent 2008, 2009 <elderme@tuxfamily.org>
 * 
 * Newt-Puzzle is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Newt-Puzzle is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _ENTITYTAB_H_
#define _ENTITYTAB_H_

#include "../newtEngine/entity.h"
#include "entityWithValue.h"


class EntityCubeTab: public EntityWithPosition
{
public:
	EntityCubeTab(int size, float interval, bool visible,
				  Vector3 axis1, Vector3 axis2, Vector3 axis3,
				  Vector3 center, Vector3 rotAxis, float angle);
	EntityCubeTab(int size, float interval, bool visible, Material *material, Mesh *mesh,
				  Vector3 axis1, Vector3 axis2, Vector3 axis3,
				  Vector3 center, Vector3 rotAxis, float angle);
	~EntityCubeTab();
		
	void insertChild(Material *material, Mesh *mesh, int value, int position1, int position2, int position3);		
		
	int getValue(int i, int j, int k);		
	int getValue(int position);
				
	bool setValue(int value, int position);
	bool setValueAndMaterial(int value, Material *material, int position);

	void setValueAndMaterialForAllEntities(int value, Material *material);		
		
	void setClickable();

	/* return how many entities have the specified value in the axis */		
	int testAxis(int direction, int position1, int position2, int value);
	int testDiag(int direction, int position, int value);
	int testDiagCube(int direction, int value);		
		
		
protected:
	int mSize;
	float mInterval;
	Vector3 mAxis1, mAxis2, mAxis3;
	
		
};

#endif // _ENTITYTAB_H_
